function [y1,v1,k1,n1,m1,y1q,v1q,k1q,n1q,m1q,hrs1,s1name]=Agg16SectorFun(y,v,k,n,m,yq,vq,kq,nq,mq,hrs,t,t0,smpl)
% Agg16SectorFun aggregates the 62 private sectors from BEA/BLS to 16
% 1-digit sectors using the mapping defined by idx1 
% 1963-2016 NAICS code industries starts with 61 private sectors
% 1947-1963 SIC code combines some of the indstries already and starts with
%           42 industries
% Different from Agg15SectorFun this separates out residential housing from
% RE. The 62-th sector is Housing and the 32/45-th sector is RE ex Housing.
% services
% A.Hornstein, 12/7/2020
% -------------------------------------------------------------------------
if smpl==1
    % 1947-1963 SIC: mapping from 43 to 16 sectors
    % idx1=[ 1 2; 3 5; 6 6; 7 7; 8 18; 19 26; 27 27; 28 28; 29 36; 37 40; 41 46; 47 52; 53 56; 57 60; 61 61; 62 62];
    idx1=[ 1 2; 3 5; 6 6; 7 7; 8 18; 19 26; 27 27; 28 28; 29 29; 30 30; 31 33; 34 36; 37 38; 39 41; 42 42; 45 45];
elseif smpl==2
    % 1963-2016 NAICS: mapping from 62 to 16 sectors
    idx1=[ 1 2; 3 5; 6 6; 7 7; 8 18; 19 26; 27 27; 28 28; 29 36; 37 40; 41 46; 47 52; 53 56; 57 60; 61 61; 64 64];
end

nI1=size(idx1,1);
s1name=cell(nI1,1);i=1;
s1name{i}='Agriculture, Forestry, Fishing, and Hunting';i=i+1;
s1name{i}='Mining';i=i+1;
s1name{i}='Utilities';i=i+1;
s1name{i}='Construction';i=i+1;
s1name{i}='Durable Goods';i=i+1;
s1name{i}='Nondurable Goods';i=i+1;
s1name{i}='Wholesale Trade';i=i+1;
s1name{i}='Retail Trade';i=i+1;
s1name{i}='Transportation and Warehousing';i=i+1;
s1name{i}='Information';i=i+1;
s1name{i}='FIRE ex Housing';i=i+1;
s1name{i}='Professional and Business Services';i=i+1;
s1name{i}='Education, Health Care, and Social Assistance';i=i+1;
s1name{i}='Arts, Entertainment, etc';i=i+1;
s1name{i}='Other Services, excl Government';i=i+1;
s1name{i}='Housing Services';

% Input and output aggregation, nominal and real
nt=length(t);
v1=NaN(nt,nI1);k1=v1;n1=v1;y1=v1;m1=v1;
v1q=v1;k1q=v1;n1q=v1;y1q=v1;m1q=v1;hrs1=v1;
for i=1:nI1  
    % i-th industry aggregate
    idx=(idx1(i,1):idx1(i,2));
    % Gross output aggregate, nominal and real
    [y1(:,i),y1q(:,i)]=DivisiaQ(y(:,idx),yq(:,idx),t,t0);
    % Capital aggregate, nominal and real
    [k1(:,i),k1q(:,i)]=DivisiaQ(k(:,idx),kq(:,idx),t,t0);
    % Labor aggregate, nominal and real
    [n1(:,i),n1q(:,i)]=DivisiaQ(n(:,idx),nq(:,idx),t,t0);
    % Intermediate input aggregate, nominal and real
    [m1(:,i),m1q(:,i)]=DivisiaQ(m(:,idx),mq(:,idx),t,t0);
    % Value added aggregate, nominal and real
    [v1(:,i),v1q(:,i)]=DivisiaQ(v(:,idx),vq(:,idx),t,t0);
    % Hours total
    hrs1(:,i)=sum(hrs(:,idx),2);
end

end

