% BEAdata_15Sector_Splice_1963_2016_with_1987_2018
% Splice the 15 sector aggregates of (1) the experimental NAICS IILPA from
% 1963-2016 with (2) the official IILPA from 1987-2018.  
% Splice the series in 1987, ie, rely on the official IILPA as much as
% possible.
% For both data sets Real=Nominal in 2012. 
%
% Hornstein, 1/11/2021
% revised 10/21/2021: define (1) spliced nominal VA as residual from spliced
% nominal gross output and intermediates, and (2) spliced capital income
% as residual from spliced nominal VA and labor
% -------------------------------------------------------------------------
fileloc='DataProcessed\';
%% BEA KLEMS data, 1963-2016, real in 2012 $'s 
fname=[fileloc 'KLEMSbea15_1963_2016_NAICS.mat' ];
load(fname,'SecName','y','v','k','n','m','yq','vq','kq','nq','mq','hrs','tt');
t1=tt;
y1=y;
v1=v;
k1=k;
n1=n;
m1=m;
yq1=yq;
vq1=vq;
kq1=kq;
nq1=nq;
mq1=mq;
hrs1=hrs;
sec1=SecName;

% -------------------------------------------------------------------------
%% BEA KLEMS data, 1987-2018, real in 2012 $'s 
fname=[fileloc 'KLEMSbea15_1987_2018_NAICS.mat'];
load(fname,'SecName','y','v','k','n','m','yq','vq','kq','nq','mq','hrs','tt');
t2=tt;
y2=y;
v2=v;
k2=k;
n2=n;
m2=m;
yq2=yq;
vq2=vq;
kq2=kq;
nq2=nq;
mq2=mq;
hrs2=hrs;
sec2=SecName;

% -------------------------------------------------------------------------
%% splice data
% tS=2016;
tS=1987;

[y,tt]=splicefun1to2(t1,y1,t2,y2,tS);
m=splicefun1to2(t1,m1,t2,m2,tS);
v=y-m;
n=splicefun1to2(t1,n1,t2,n2,tS);
k=v-n;
yq=splicefun1to2(t1,yq1,t2,yq2,tS);
vq=splicefun1to2(t1,vq1,t2,vq2,tS);
mq=splicefun1to2(t1,mq1,t2,mq2,tS);
nq=splicefun1to2(t1,nq1,t2,nq2,tS);
kq=splicefun1to2(t1,kq1,t2,kq2,tS);
hrs=splicefun1to2(t1,hrs1,t2,hrs2,tS);

[dzy,dzv]=TFPfun(yq,vq,kq,nq,mq,k,n,m);

fnameMERGE='KLEMSbea15_1963_1987_2018_NAICS';
fnameMERGE=[fileloc fnameMERGE '.mat'];
save(fnameMERGE,'SecName','y','v','k','n','m','yq','vq','kq','nq','mq','dzy','dzv','hrs','tt');

% % -------------------------------------------------------------------------
% %% plot spliced series
% s1=(tt<=tS);
% s2=(tt>=tS);
% nt1=length(tt(s1));
% nt2=length(tt(s2));
% % nominal
% nfig=100;
% nI=length(SecName);
% for i=1:nI
%     nfig=nfig+1;figure(nfig);clf;
%     subplot(2,2,1); hold on;
%     x=y;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: Y',sec2{i}));
%     subplot(2,2,2); hold on;
%     x=m;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: M',sec2{i}));
%     subplot(2,2,3); hold on;
%     x=k;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: K',sec2{i}));
%     subplot(2,2,4); hold on;
%     x=n;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: N',sec2{i}));
% end
% % real series
% nfig=200;
% for i=1:nI
%     nfig=nfig+1;figure(nfig);clf;
%     subplot(3,2,1); hold on;
%     x=yq;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: y',sec2{i}));
%     subplot(3,2,2); hold on;
%     x=mq;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: m',sec2{i}));
%     subplot(3,2,3); hold on;
%     x=kq;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: k',sec2{i}));
%     subplot(3,2,4); hold on;
%     x=nq;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: n',sec2{i}));
%     subplot(3,2,5); hold on;
%     x=hrs;
%     semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
%     semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
%     title(sprintf('%10s: h',sec2{i}));
% end

% %% "wrong" definition of nominal value added and capital income
% vA=splicefun1to2(t1,v1,t2,v2,tS);
% kA=splicefun1to2(t1,k1,t2,k2,tS);
% [dzyA,dzvA]=TFPfun(yq,vq,kq,nq,mq,kA,n,m);
% nI=size(kA,2);
% for i=1:nI
%     figure(i);
%     plot(tt,log(v(:,i)),'r-+',tt,log(vA(:,i)),'b-o');
%     xlim([tt(1) 1986]);
%     title(['VA:' SecName{i}]);
% end
% for i=1:nI
%     figure(100+i);
%     plot(tt,log(k(:,i)),'r-+',tt,log(kA(:,i)),'b-o');
%     xlim([tt(1) 1986]);
%     title(['Capital:' SecName{i}]);
% end
% for i=1:nI
%     figure(200+i);
%     plot(tt,k(:,i)./v(:,i),'r-+',tt,kA(:,i)./vA(:,i),'b-o');
%     xlim([tt(1) 1986]);
%     title(['Capital-VA Income Share:' SecName{i}]);
% end
% for i=1:nI
%     figure(300+i);
%     plot(tt,dzy(:,i),'r-+',tt,dzyA(:,i),'b-o');
%     xlim([tt(1) 1986]);
%     title(['d TFP:' SecName{i}]);
% end
% 
% 
% 
