% BEAdata_16Sector_Splice_1947_1963_with_1963_1987_2018
% Splice the 16 sector aggregates of (1) the experimental NAICS IILPA from
% 1947-1963 with (2) the combined experimental and official NAICS IILPA
% from 1963-2018, merged in 1987.  
%
% Hornstein, 12/7/2020
% revised 10/21/2021: define (1) spliced nominal VA as residual from spliced
% nominal gross output and intermediates, and (2) spliced capital income
% as residual from spliced nominal VA and labor
% -------------------------------------------------------------------------
% SetPath
fileloc='DataProcessed\';
% -------------------------------------------------------------------------
% BEA KLEMS data, 1947-1963, real in 1963 $'s 
fname1='KLEMSbea16_1947_1963_SIC';
fname1=[fileloc fname1 '.mat'];
load(fname1,'SecName','y','v','k','n','m','yq','vq','kq','nq','mq','dzy','dzv','hrs','tt');
t1=tt;
y1=y;
v1=v;
k1=k;
n1=n;
m1=m;
yq1=yq;
vq1=vq;
kq1=kq;
nq1=nq;
mq1=mq;
dzy1=dzy;
dzv1=dzv;
hrs1=hrs;
sec1=SecName;

% -------------------------------------------------------------------------
% BEA KLEMS data, 1963-2018, real in 2012 $'s 
fname2='KLEMSbea16_1963_1987_2018_NAICS';
fname2=[fileloc fname2 '.mat'];
load(fname2,'SecName','y','v','k','n','m','yq','vq','kq','nq','mq','dzy','dzv','hrs','tt');
t2=tt;
y2=y;
v2=v;
k2=k;
n2=n;
m2=m;
yq2=yq;
vq2=vq;
kq2=kq;
nq2=nq;
mq2=mq;
dzy2=dzy;
dzv2=dzv;
hrs2=hrs;
sec2=SecName;
% 
% % -------------------------------------------------------------------------
% % compare nominal series
% nI=size(y2,2);
% nfig=0;
% for i=1:nI
%     nfig=nfig+1;figure(nfig);clf;
%     subplot(3,2,1);
%     semilogy(t1,y1(:,i),'r-', t2,y2(:,i),'b-');
%     title(sprintf('%10s: Y',sec2{i}));
%     subplot(3,2,2);
%     semilogy(t1,m1(:,i),'r-', t2,m2(:,i),'b-');
%     title(sprintf('%10s: M',sec2{i}));
%     subplot(3,2,3);
%     semilogy(t1,k1(:,i),'r-', t2,k2(:,i),'b-');
%     title(sprintf('%10s: K',sec2{i}));
%     subplot(3,2,4);
%     semilogy(t1,n1(:,i),'r-', t2,n2(:,i),'b-');
%     title(sprintf('%10s: N',sec2{i}));
%     subplot(3,2,5);
%     semilogy(t1,hrs1(:,i),'r-', t2,hrs2(:,i),'b-');
%     title(sprintf('%10s: HRS',sec2{i}));
% end
% pause;
% 
% -------------------------------------------------------------------------
%% splice data
tS=1963;

[y,tt]=splicefun1to2(t1,y1,t2,y2,tS);
m=splicefun1to2(t1,m1,t2,m2,tS);
v=y-m;
n=splicefun1to2(t1,n1,t2,n2,tS);
k=v-n;
% [y,tt]=splicefun1to2(t1,y1,t2,y2,tS);
% v=splicefun1to2(t1,v1,t2,v2,tS);
% m=splicefun1to2(t1,m1,t2,m2,tS);
% n=splicefun1to2(t1,n1,t2,n2,tS);
% k=splicefun1to2(t1,k1,t2,k2,tS);
yq=splicefun1to2(t1,yq1,t2,yq2,tS);
vq=splicefun1to2(t1,vq1,t2,vq2,tS);
mq=splicefun1to2(t1,mq1,t2,mq2,tS);
nq=splicefun1to2(t1,nq1,t2,nq2,tS);
kq=splicefun1to2(t1,kq1,t2,kq2,tS);
hrs=splicefun1to2(t1,hrs1,t2,hrs2,tS);

[dzy,dzv]=TFPfun(yq,vq,kq,nq,mq,k,n,m);

% -------------------------------------------------------------------------
%% plot spliced series
s1=(tt<=tS);
s2=(tt>=tS);
nt1=length(tt(s1));
nt2=length(tt(s2));
% nominal
nfig=100;
nI=length(SecName);
for i=1:nI
    nfig=nfig+1;figure(nfig);clf;
    subplot(2,2,1); hold on;
    x=y;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: Y',sec2{i}));
    subplot(2,2,2); hold on;
    x=m;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: M',sec2{i}));
    subplot(2,2,3); hold on;
    x=k;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: K',sec2{i}));
    subplot(2,2,4); hold on;
    x=n;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: N',sec2{i}));
end
% real series
nfig=200;
for i=1:nI
    nfig=nfig+1;figure(nfig);clf;
    subplot(3,2,1); hold on;
    x=yq;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: y',sec2{i}));
    subplot(3,2,2); hold on;
    x=mq;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: m',sec2{i}));
    subplot(3,2,3); hold on;
    x=kq;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: k',sec2{i}));
    subplot(3,2,4); hold on;
    x=nq;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: n',sec2{i}));
    subplot(3,2,5); hold on;
    x=hrs;
    semilogy(tt(s1),x(s1,i),'r-o', 'MarkerIndices',[1 nt1]);
    semilogy(tt(s2),x(s2,i),'b-x', 'MarkerIndices',[1 nt2]);
    title(sprintf('%10s: h',sec2{i}));
end

fnameMERGE='KLEMSbea16_1947_1963_1987_2018';
fnameMERGE=[fileloc fnameMERGE '.mat'];
save(fnameMERGE,'SecName','y','v','k','n','m','yq','vq','kq','nq','mq','hrs','dzy','dzv','tt');
