x = va_agg;
T_obs = size(calvec,1);
q = 8;
% Construct sample mean and cosine transform, etc
[X,xbar,xproj] = cos_transform(x,q);
[~,~,xproj_6] = cos_transform(x,6);

fvec = pi*(1:1:q);
tvec = (0.5:1:T_obs)'/T_obs;
A = (sqrt(2/T_obs))*cos(tvec*fvec);
T_vec = (1:1:T_obs)';

% Values to plot
off_set = 0.9;
A_plot = A;
for i = 2:q
    oo = (i-1)*off_set;
    A_plot(:,i) = A_plot(:,i)-oo;
end
A_plot = [-0.35+ones(T_obs,1) A_plot];

fig = figure;
ax_fs = 25;
% Form Picture
subplot(2,2,1);
plot(calvec,x,'- k','LineWidth',1);
xlim([1945 2020]);
title('(a) GDP Growth Rate');
% ax = gca;
% ax.FontSize = ax_fs;

subplot(2,2,2);
plot(calvec,A_plot(:,1),'- b','LineWidth',2);
hold on;
    plot(calvec,A_plot(:,2:end),'- r','LineWidth',2);
hold off;
xlim([1945 2020]);
ylim([-7 1.5]);
set(gca,'ytick',[])
title('(b) Low-frequency regressors');
% ax = gca;
% ax.FontSize = ax_fs;

subplot(2,2,3);
plot(calvec,x,'- k','LineWidth',1);
hold on;
plot(calvec,xproj,'- b','LineWidth',2);
plot(calvec,xproj_6,': b','LineWidth',2);
hold off;
title('(c) Actual and Low-Frequency Fitted Values')
xlim([1945 2020]);
legend('GDP growth rates','Trend (q=8)','Trend (q=6)','Location','SouthWest');

% ax = gca;
% ax.FontSize = ax_fs;

xvec = (1:q)';
subplot(2,2,4);
plot(xvec,X,'+k','MarkerSize',10,'LineWidth',3);
title({'(d) Low-frequency regression coeficients'});
ylim([-10 10]);
xlim([0 9]);
xt = (0:1:q+1);
xticks(xt);

orient landscape;
print(fig, [figdir 'Figure_A1'], '-dpdf','-bestfit');
close(gcf);