% Summarize Results .. 4 Models .. Figure 11
%#ok<*NASGU> 
clear;
small = 1.0e-10;
big = 1.0e+5;                  
rng(63761);
this_date = datestr(now,'yyyymmdd');
 
% -- File Directories  
outdir = 'out/';
figdir = 'fig/';
matdir = 'mat/';
 

% Include directory with misc project-specific functions
p1 = path;
path(p1,'m_utilities');

% Read data
Read_data;

fig = figure;
rf = 4;
cf = 3;
irf = 0;


% -- TABLE Posterior -- %
 outfile_name    = [outdir, 'Figure_11_summary.txt'];
 fileID          = fopen(outfile_name,'w');


% Model 1
q=8;
eta = 1.0;     % Prior SD for lambda
nma_fig = 11;  % MA order for figures
mlabel = ['lf_' num2str(eta*10) '_' num2str(q)];

% Construct LF trends and Moving-averages
lf_ma_components;

% % Summarize Posterior .. Results reported in Paper
plot_fig_11_panel;

% Model 2
irf = irf+3;
q=8;
eta = 0.5;     % Prior SD for lambda
nma_fig = 11;  % MA order for figures 
mlabel = ['lf_' num2str(eta*10) '_' num2str(q)];

% Construct LF trends and Moving-averages
lf_ma_components;

% % Summarize Posterior .. Results reported in Paper
plot_fig_11_panel;

% Model 3
irf = irf+3;
q=8;
eta = 2.0;     % Prior SD for lambda
nma_fig = 11;  % MA order for figures
mlabel = ['lf_' num2str(eta*10) '_' num2str(q)];

% Construct LF trends and Moving-averages
lf_ma_components;

% % Summarize Posterior .. Results reported in Paper
plot_fig_11_panel;

% Model 4
irf = irf+3;
q=6;
eta = 1.0;     % Prior SD for lambda
nma_fig = 11;  % MA order for figures
mlabel = ['lf_' num2str(eta*10) '_' num2str(q)];

% Construct LF trends and Moving-averages
lf_ma_components;

% % Summarize Posterior .. Results reported in Paper
plot_fig_11_panel;

%orient landscape;
print(fig, [figdir, 'Figure_11'], '-dpdf','-bestfit');
close(gcf);

fclose(fileID);


% Reset path
path(p1);
 