
% Figure 1 and Table 1 from existing paper .. 
% Centered Moving Averages
y_mat = [va_aggregate_data_chain va_aggregate_data_fixed_weight va_aggregate_data_first va_aggregate_data_last];
xma = NaN(size(y_mat));
tmp = ma(y_mat,nma_fig);
aa = (nma_fig-1)/2;
xma(aa+1:end-aa,:)=tmp(nma_fig:end,:);
va_aggregate_data_chain_ma = xma(:,1); 
va_aggregate_data_fixed_weight_ma = xma(:,2);
va_aggregate_data_first_ma = xma(:,3); 
va_aggregate_data_last_ma = xma(:,4);

y_mat = [va_aggregate_data_chain_ca va_aggregate_data_fixed_weight_ca va_aggregate_data_first_ca va_aggregate_data_last_ca];
xma = NaN(size(y_mat));
tmp = ma(y_mat,nma_fig);
aa = (nma_fig-1)/2;
xma(aa+1:end-aa,:)=tmp(nma_fig:end,:);
va_aggregate_data_chain_ca_ma = xma(:,1); 
va_aggregate_data_fixed_weight_ca_ma = xma(:,2);
va_aggregate_data_first_ca_ma = xma(:,3); 
va_aggregate_data_last_ca_ma = xma(:,4);

years = calvec_all;

% -- FIGURE 1: GDP GROWTH -- %
fig = figure;
subplot(2,2,1)
    hold on;
    title('(a) GDP Growth')
    plot(calvec_all,va_aggregate_data_fixed_weight,'-k','LineWidth',2)
    plot(calvec_all,va_aggregate_data_chain,':r','LineWidth',2);
    plot(calvec_all,va_aggregate_data_first,'-.b','LineWidth',2);
    plot(calvec_all,va_aggregate_data_last,'--m','LineWidth',2);
    plot(1950:2020,zeros(71,1),':k');
    xlim([1950 2020])
subplot(2,2,2)
    hold on;
    str = [num2str(nma_fig) '-Year Centered Moving Average'];
    title({'(b) GDP Growth',str})
    plot(calvec_all,va_aggregate_data_fixed_weight_ma,'-k','LineWidth',2)
    plot(calvec_all,va_aggregate_data_chain_ma,':r','LineWidth',2);
    plot(calvec_all,va_aggregate_data_first_ma,'-.b','LineWidth',2);
    plot(calvec_all,va_aggregate_data_last_ma,'--m','LineWidth',2);
    plot(1950:2020,zeros(71,1),':k');
    xlim([1950 2020])
subplot(2,2,3)
    hold on;
    title('(c) Cyclically Adjusted GDP Growth')
    plot(calvec_all,va_aggregate_data_fixed_weight_ca,'-k','LineWidth',2)
    plot(calvec_all,va_aggregate_data_chain_ca,':r','LineWidth',2);
    plot(calvec_all,va_aggregate_data_first_ca,'-.b','LineWidth',2);
    plot(calvec_all,va_aggregate_data_last_ca,'--m','LineWidth',2);
    plot(1950:2020,zeros(71,1),':k');
    xlim([1950 2020])
subplot(2,2,4)
    hold on;
    str = [num2str(nma_fig) '-Year Centered Moving Average'];
    title({'(d) Cyclically-Adjusted GDP Growth',str})
    plot(calvec_all,va_aggregate_data_fixed_weight_ca_ma,'-k','LineWidth',2)
    plot(calvec_all,va_aggregate_data_chain_ca_ma,':r','LineWidth',2);
    plot(calvec_all,va_aggregate_data_first_ca_ma,'-.b','LineWidth',2);
    plot(calvec_all,va_aggregate_data_last_ca_ma,'--m','LineWidth',2);
    plot(1950:2020,zeros(71,1),':k');
    xlim([1950 2020])
    legend('Constant Mean Weights (Full Sample)','Chain Weights','Constant Mean Weights (First 15 Years)','Constant Mean Weights (Last 15 Years)','Location','Southwest');
orient landscape;
print(fig, [figdir, 'Figure_01'], '-dpdf','-bestfit');
close(gcf);

% -- TABLE 1: GDP GROWTH -- %
outfile_name    = [outdir, 'Table_01.csv'];
fileID          = fopen(outfile_name,'w');
fprintf(fileID,'SMPL, Growth Rate, CA Growth Rate \n');
fprintf(fileID,'1950-2018,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f ,%5.1f,%5.1f \n', ...
    [mean(va_aggregate_data_fixed_weight(find(years==1950):find(years==2018)))   
       mean(va_aggregate_data_fixed_weight_ca(find(years==1950):find(years==2018)))
       mean(va_aggregate_data_chain(find(years==1950):find(years==2018)))   
       mean(va_aggregate_data_chain_ca(find(years==1950):find(years==2018)))
       mean(va_aggregate_data_first(find(years==1950):find(years==2018)))   
       mean(va_aggregate_data_first_ca(find(years==1950):find(years==2018)))
       mean(va_aggregate_data_last(find(years==1950):find(years==2018)))   
       mean(va_aggregate_data_last_ca(find(years==1950):find(years==2018)))]);
fprintf(fileID,'1950-1966,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f ,%5.1f,%5.1f \n', ...
    [mean(va_aggregate_data_fixed_weight(find(years==1950):find(years==1966)))   
       mean(va_aggregate_data_fixed_weight_ca(find(years==1950):find(years==1966)))
       mean(va_aggregate_data_chain(find(years==1950):find(years==1966)))   
       mean(va_aggregate_data_chain_ca(find(years==1950):find(years==1966)))
       mean(va_aggregate_data_first(find(years==1950):find(years==1966)))   
       mean(va_aggregate_data_first_ca(find(years==1950):find(years==1966)))
       mean(va_aggregate_data_last(find(years==1950):find(years==1966)))   
       mean(va_aggregate_data_last_ca(find(years==1950):find(years==1966)))]);
fprintf(fileID,'1967-1983,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f ,%5.1f,%5.1f \n', ...
    [mean(va_aggregate_data_fixed_weight(find(years==1967):find(years==1983)))   
       mean(va_aggregate_data_fixed_weight_ca(find(years==1967):find(years==1983)))
       mean(va_aggregate_data_chain(find(years==1967):find(years==1983)))   
       mean(va_aggregate_data_chain_ca(find(years==1967):find(years==1983)))
       mean(va_aggregate_data_first(find(years==1967):find(years==1983)))   
       mean(va_aggregate_data_first_ca(find(years==1967):find(years==1983)))
       mean(va_aggregate_data_last(find(years==1967):find(years==1983)))   
       mean(va_aggregate_data_last_ca(find(years==1967):find(years==1983)))]);
fprintf(fileID,'1984-2000,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f ,%5.1f,%5.1f \n', ...
    [mean(va_aggregate_data_fixed_weight(find(years==1984):find(years==2000)))   
       mean(va_aggregate_data_fixed_weight_ca(find(years==1984):find(years==2000)))
       mean(va_aggregate_data_chain(find(years==1984):find(years==2000)))   
       mean(va_aggregate_data_chain_ca(find(years==1984):find(years==2000)))
       mean(va_aggregate_data_first(find(years==1984):find(years==2000)))   
       mean(va_aggregate_data_first_ca(find(years==1984):find(years==2000)))
       mean(va_aggregate_data_last(find(years==1984):find(years==2000)))   
       mean(va_aggregate_data_last_ca(find(years==1984):find(years==2000)))]);
fprintf(fileID,'2001-2018,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f,%5.1f ,%5.1f,%5.1f \n', ...
    [mean(va_aggregate_data_fixed_weight(find(years==2001):find(years==2018)))   
       mean(va_aggregate_data_fixed_weight_ca(find(years==2001):find(years==2018)))
       mean(va_aggregate_data_chain(find(years==2001):find(years==2018)))   
       mean(va_aggregate_data_chain_ca(find(years==2001):find(years==2018)))
       mean(va_aggregate_data_first(find(years==2001):find(years==2018)))   
       mean(va_aggregate_data_first_ca(find(years==2001):find(years==2018)))
       mean(va_aggregate_data_last(find(years==2001):find(years==2018)))
       mean(va_aggregate_data_last_ca(find(years==2001):find(years==2018)))]);
fclose(fileID);

% Figure 2
% -- FIGURE 1: GDP GROWTH -- %
fig = figure;
    hold on;
    plot(calvec_all,va_aggregate_data_fixed_weight_ca,'-k','LineWidth',1)
    plot(calvec_all,va_aggregate_data_fixed_weight_ca_ma,'-- r','LineWidth',2)
    bb = size(calvec_all,1)-size(calvec,1);
    tmp = [NaN(bb,1);xproj_va_agg];
    plot(calvec_all,tmp,'-b','LineWidth',2)
    plot(1950:2020,zeros(71,1),':k');
    xlim([1950 2020])
    legend('Growth Rate (Cyc. Adjusted)','11-year centered moving average','Low-frequency trend','Location','Southwest');
orient landscape;
print(fig, [figdir, 'Figure_02'], '-dpdf','-bestfit');
close(gcf);
