% Summarize Results .. Master Program
%
clear;
small = 1.0e-10;
big = 1.0e+5;                  
rng(63761);
this_date = datestr(now,'yyyymmdd');

% Include directory with misc project-specific functions
p1 = path;
path(p1,'m_utilities');
 
% -- File Directories  
outdir = 'out/';
figdir = 'fig/';
matdir = 'mat/';

% Read data
Read_data;

% Parameters for Benchmark model calculations
q=8;
eta = 1.0;     % Prior SD for lambda
mlabel = ['lf_' num2str(eta*10) '_' num2str(q)];

% Construct LF trends and Moving-averages
nma_fig = 11;  % MA order for figures
q = 8;         % q value for LF trend
lf_ma_components;

% Summarize Posterior .. Results reported in Paper
summarize_posterior_paper;

% Reset path
path(p1);


   


  
  

  