function [WT,Y,yproj] = WT_avg(y,q);
% Compute WT averages
% Inputs
% y is data
% q .. number of cosine transforms
% Outputs: 
% WT .. matrix of weights
% Y = WT'*x
% yproj = WT*Y

 n_t = size(y,1);
 n_s = size(y,2);
 
 % --- Use Analytic Formula for eigenvalues
 fvec = pi*(1:1:q);
 tvec = (0.5:1:n_t)'/n_t;
 A = (sqrt(2))*cos(tvec*fvec);
 WT = [ones(n_t,1) A];
 Y = (WT'*y)/n_t;
 yproj = WT*Y;
 
end

