% Plot 1 panel of Figure 11
% Shade Colors
Cl1 = 'LightPink';
Cl2 = 'PowderBlue';

% Draw Results from MCMC
str_tmp = [matdir 'lam_draws_emp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_draws_tfp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'f_draws_emp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'f_draws_tfp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'sigma_f_draws_' mlabel]; load(str_tmp);
str_tmp = [matdir 'sigma_u_draws_' mlabel]; load(str_tmp);
str_tmp = [matdir 'g_f_draws_' mlabel]; load(str_tmp);
str_tmp = [matdir 'g_u_draws_' mlabel]; load(str_tmp);

% Save information on priors
str_tmp = [matdir 'nu_prior_u_' mlabel]; load(str_tmp);
str_tmp = [matdir 's2_prior_u_' mlabel]; load(str_tmp);
str_tmp = [matdir 'nu_prior_f_' mlabel]; load(str_tmp);
str_tmp = [matdir 's2_prior_f_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_mean_prior_emp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_var_prior_emp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_mean_prior_tfp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_var_prior_tfp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'g_grid_' mlabel]; load(str_tmp);
str_tmp = [matdir 'g_prior_' mlabel]; load(str_tmp);
n_g_grid = size(g_grid,1);
n_draws = size(lam_draws_emp,2);

% Some Covariance Matrices~
[WT,~,~] = WT_avg(zeros(T_obs,1),q);
W = WT(:,2:end)/T_obs;
S_I0 = eye(T_obs);
S_I1 = (1/T_obs^2)*rw_cov(T_obs);
SW_I0 = W'*S_I0*W;
SW_I1 = W'*S_I1*W;
diag_SW_I0 = diag(SW_I0);
diag_SW_I1 = diag(SW_I1);

% Summary Table 

% Plot sector-specific contributions to aggregates by sector
% Decompose aggregates into common unique components
e_draws_emp = NaN(n_y,q,n_draws);
e_draws_tfp = NaN(n_y,q,n_draws);
for i = 1:n_y
    e_draws_emp(i,:,:)=repmat(X_emp_sec(:,i),1,n_draws)-repmat(lam_draws_emp(i,:),q,1).*f_draws_emp;
    e_draws_tfp(i,:,:)=repmat(X_tfp_sec(:,i),1,n_draws)-repmat(lam_draws_tfp(i,:),q,1).*f_draws_tfp;
end

% Compute and plot results Value-added results
% Read in the multipliers from Andrew
filename = 'Long Run Multipliers.xlsx';  
xlsname = ['../data/' filename];
lrm_tfp = xlsread(xlsname,'A1:A16');  
lrm_emp = xlsread(xlsname,'B1:B16');

% Construct model-based decomposition of GDP
% GDP Data and LR trends
% va_agg = GDP
% xproj_va_agg = lf component
xproj_va_agg_emp = xproj_emp_sec*lrm_emp;
xproj_va_agg_tfp = xproj_tfp_sec*lrm_tfp;
xproj_va_agg_model = xproj_va_agg_emp+xproj_va_agg_tfp;

% Carry out decomposition (demeaned throughout) 
xproj_dm_va_agg_emp = xproj_dm_emp_sec*lrm_emp;
xproj_dm_va_agg_tfp = xproj_dm_tfp_sec*lrm_tfp;
xproj_dm_va_agg_model = xproj_dm_va_agg_emp+xproj_dm_va_agg_tfp;

tmp = lrm_emp'*lam_draws_emp;
tmp = repmat(tmp,q,1).*f_draws_emp;
tmp = WT(:,2:end)*tmp;
xproj_dm_va_agg_emp_f = pctile(tmp',[0.5 1/6 5/6])';

tmp = lrm_tfp'*lam_draws_tfp;
tmp = repmat(tmp,q,1).*f_draws_tfp;
tmp = WT(:,2:end)*tmp;
xproj_dm_va_agg_tfp_f = pctile(tmp',[0.5 1/6 5/6])';

ee_draws_emp = NaN(q,n_draws);
ee_draws_tfp = NaN(q,n_draws);
for iq = 1:q
    tmp = squeeze(e_draws_emp(:,iq,:));
    ee_draws_emp(iq,:)=lrm_emp'*tmp;
    tmp = squeeze(e_draws_tfp(:,iq,:));
    ee_draws_tfp(iq,:)=lrm_tfp'*tmp;
end
tmp = WT(:,2:end)*ee_draws_emp;
xproj_dm_va_agg_emp_u = pctile(tmp',[0.5 1/6 5/6])';
tmp = WT(:,2:end)*ee_draws_tfp;
xproj_dm_va_agg_tfp_u = pctile(tmp',[0.5 1/6 5/6])';

xproj_dm_va_agg_f = xproj_dm_va_agg_emp_f + xproj_dm_va_agg_tfp_f;
xproj_dm_va_agg_u = xproj_dm_va_agg_emp_u + xproj_dm_va_agg_tfp_u;


x = calvec;
x2 = [x;flipud(x)];
subplot(rf,cf,irf+1);
plot(calvec,xproj_dm_va_agg_model,'- b','LineWidth',2);
hold on;
z = [xproj_dm_va_agg_f(:,2);flipud(xproj_dm_va_agg_f(:,3))];
ii = (~isnan(z));
fill(x2(ii==1),z(ii==1),rgb(Cl1),'EdgeColor','none');
plot(calvec,xproj_dm_va_agg_f(:,1),'- r','LineWidth',2);
plot(calvec,xproj_dm_va_agg_model,'- k','LineWidth',2);
hold off;
xlim([1950 2020]);

subplot(rf,cf,irf+2);
plot(calvec,xproj_dm_va_agg_model,'- b','LineWidth',2);
hold on;
    z = [xproj_dm_va_agg_u(:,2);flipud(xproj_dm_va_agg_u(:,3))];
    ii = (~isnan(z));
    fill(x2(ii==1),z(ii==1),rgb(Cl1),'EdgeColor','none');
    plot(calvec,xproj_dm_va_agg_u(:,1),'- r','LineWidth',2);
    plot(calvec,xproj_dm_va_agg_model,'- k','LineWidth',2);
hold off;
xlim([1950 2020]);

% Compute posteriors for lambdas for GDP and Compute R-squared for
% common factors
lam_emp_va_draws = (lrm_emp'*lam_draws_emp)';
lam_emp_va = pctile(lam_emp_va_draws,[0.5 1/6 5/6]);
lam_tfp_va_draws = (lrm_tfp'*lam_draws_tfp)';
lam_tfp_va = pctile(lam_tfp_va_draws,[0.5 1/6 5/6]);

% Compute R2 

var_emp_u_all = NaN(n_y,n_draws);
var_tfp_u_all = NaN(n_y,n_draws);
cov_emp_tfp_u_all = NaN(n_y,n_draws);
for j = 1:n_y

    sigma_u_emp = squeeze(sigma_u_draws(1,1,j,:));
    g_emp_u = squeeze(g_u_draws(1,j,:));
    var_emp_u = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_u.^2);
    var_emp_u = sigma_u_emp.*var_emp_u;

    sigma_u_tfp = squeeze(sigma_u_draws(2,2,j,:));
    g_tfp_u = squeeze(g_u_draws(2,j,:));
    var_tfp_u = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_tfp_u.^2);
    var_tfp_u = sigma_u_tfp.*var_tfp_u;

    % Correlation of u components;
    sigma_u_emp_tfp = squeeze(sigma_u_draws(1,2,j,:));
    cov_u = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_u.*g_tfp_u);
    cov_u = sigma_u_emp_tfp.*cov_u;
    cor_u = cov_u./sqrt(var_emp_u .*var_tfp_u);

    % Save
    var_emp_u_all(j,:) = var_emp_u;
    var_tfp_u_all(j,:) = var_tfp_u;
    cov_emp_tfp_u_all(j,:) = cov_u;
end

sigma_f_emp = squeeze(sigma_f_draws(1,1,:));
g_emp_f = g_f_draws(1,:)';
var_emp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_f.^2);
var_emp_f = (lam_emp_va_draws.^2).*sigma_f_emp.*var_emp_f;
sigma_f_tfp = squeeze(sigma_f_draws(2,2,:));
g_tfp_f = g_f_draws(2,:)';
var_tfp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_tfp_f.^2);
var_tfp_f = (lam_tfp_va_draws.^2).*sigma_f_tfp.*var_tfp_f;
sigma_f_emp_tfp = squeeze(sigma_f_draws(1,2,:));
cov_emp_tfp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_f.*g_tfp_f);
cov_emp_tfp_f = (lam_emp_va_draws.*lam_tfp_va_draws).*sigma_f_emp_tfp.*cov_emp_tfp_f;
var_f = var_emp_f + var_tfp_f + 2*cov_emp_tfp_f;

var_emp_u = ((lrm_emp.^2)'*var_emp_u_all)';
var_tfp_u = ((lrm_tfp.^2)'*var_tfp_u_all)';
cov_emp_tfp_u = ((lrm_emp.*lrm_tfp)'*cov_emp_tfp_u_all)';
var_u = var_emp_u + var_tfp_u + 2*cov_emp_tfp_u;

R2 = var_f./(var_f+var_u);
[p_post,x_post] = ksdensity(R2);

% Some Summary Statistics for R2 for paragraph in paper
R2_sum = pctile(R2,[0.50 1/6 5/6]);
fprintf(fileID,'Results for: \n');
fprintf(fileID,'  q = %3i  eta = %5.2f \n',[q eta]);
fprintf(fileID,'  R2 med (CI): %5.2f (%5.2f, %5.2f) \n \n',R2_sum);

subplot(rf,cf,irf+3);
plot(x_post,p_post,'LineWidth',2);
xlim([0 1]);

