% Summarize the posterior Table and Figures used in paper
% Parameters for Benchmark model calculations
% Draw Results from MCMC
str_tmp = [matdir 'lam_draws_emp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_draws_tfp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'f_draws_emp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'f_draws_tfp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'sigma_f_draws_' mlabel]; load(str_tmp);
str_tmp = [matdir 'sigma_u_draws_' mlabel]; load(str_tmp);
str_tmp = [matdir 'g_f_draws_' mlabel]; load(str_tmp);
str_tmp = [matdir 'g_u_draws_' mlabel]; load(str_tmp);

% Save information on priors
str_tmp = [matdir 'nu_prior_u_' mlabel]; load(str_tmp);
str_tmp = [matdir 's2_prior_u_' mlabel]; load(str_tmp);
str_tmp = [matdir 'nu_prior_f_' mlabel]; load(str_tmp);
str_tmp = [matdir 's2_prior_f_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_mean_prior_emp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_var_prior_emp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_mean_prior_tfp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'lam_var_prior_tfp_' mlabel]; load(str_tmp);
str_tmp = [matdir 'g_grid_' mlabel]; load(str_tmp);
str_tmp = [matdir 'g_prior_' mlabel]; load(str_tmp);
n_g_grid = size(g_grid,1);
n_draws = size(lam_draws_emp,2);

% Some Covariance Matrices~
[WT,~,~] = WT_avg(zeros(T_obs,1),q);
W = WT(:,2:end)/T_obs;
S_I0 = eye(T_obs);
S_I1 = (1/T_obs^2)*rw_cov(T_obs);
SW_I0 = W'*S_I0*W;
SW_I1 = W'*S_I1*W;
diag_SW_I0 = diag(SW_I0);
diag_SW_I1 = diag(SW_I1);

% Summary Table 

% construct a table with 68% and 90% credible sets
lam_emp_rslt = NaN(n_y,5);
lam_tfp_rslt = NaN(n_y,5);
r2_emp_rslt = NaN(n_y,5);
r2_tfp_rslt = NaN(n_y,5);
cor_emp_tfp_rslt = NaN(n_y,5);
g_f_emp_rslt = NaN(5,1);
g_f_tfp_rslt = NaN(5,1);
g_u_emp_rslt = NaN(n_y,5);
g_u_tfp_rslt = NaN(n_y,5);
sig_f_emp_rslt = NaN(5,1);  % Sigma .. not sigma^2 .. take square root
sig_f_tfp_rslt = NaN(5,1);
cov_f_emptfp_rslt = NaN(5,1);
cor_f_emptfp_rslt = NaN(5,1);
sig_u_emp_rslt = NaN(n_y,5);  % Sigma .. not sigma^2 .. take square root
sig_u_tfp_rslt = NaN(n_y,5);
cov_u_emptfp_rslt = NaN(n_y,5);
r2_emp_agg_rslt = NaN(5,1);
r2_tfp_agg_rslt = NaN(5,1);


sigma_f_emp = squeeze(sigma_f_draws(1,1,:));
g_emp_f = g_f_draws(1,:)';
sig_f_emp_rslt(:,1) = pctile(sqrt(sigma_f_emp),[0.5 1/6 5/6 0.05 0.95]);
g_f_emp_rslt(:,1) = pctile(g_emp_f,[0.5 1/6 5/6 0.05 0.95]);

sigma_f_tfp = squeeze(sigma_f_draws(2,2,:));
g_tfp_f = g_f_draws(2,:)';
sig_f_tfp_rslt(:,1) = pctile(sqrt(sigma_f_tfp),[0.5 1/6 5/6 0.05 0.95]);
g_f_tfp_rslt(:,1) = pctile(g_tfp_f,[0.5 1/6 5/6 0.05 0.95]);

cov_f_emptfp = squeeze(sigma_f_draws(1,2,:));
cov_f_emptfp_rslt(:,1) = pctile(cov_f_emptfp,[0.5 1/6 5/6 0.05 0.95]);


cov_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_f.*g_tfp_f);
cov_f = cov_f_emptfp.*cov_f;
var_emp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_f.^2);
var_emp_f = sigma_f_emp.*var_emp_f;
var_tfp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_tfp_f.^2);
var_tfp_f = sigma_f_tfp.*var_tfp_f;
cor_f = cov_f./sqrt(var_emp_f .*var_tfp_f);
cor_f_emptfp_rslt(:,1) = pctile(cor_f,[0.5 1/6 5/6 0.05 0.95]);

var_emp_u_all = NaN(n_y,n_draws);
var_tfp_u_all = NaN(n_y,n_draws);
cov_emp_tfp_u_all = NaN(n_y,n_draws);
for j = 1:n_y
    lam_emp_rslt(j,:) = pctile(lam_draws_emp(j,:)',[0.5 1/6 5/6 0.05 0.95]);
    lam_tfp_rslt(j,:) = pctile(lam_draws_tfp(j,:)',[0.5 1/6 5/6 0.05 0.95]);

    % Compute Variance Components
    lam_emp_2 = (lam_draws_emp(j,:).^2)';
    lam_tfp_2 = (lam_draws_tfp(j,:).^2)';

    sigma_f_emp = squeeze(sigma_f_draws(1,1,:));
    g_emp_f = g_f_draws(1,:)';
    var_emp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_f.^2);
    var_emp_f = lam_emp_2.*sigma_f_emp.*var_emp_f;
    sigma_u_emp = squeeze(sigma_u_draws(1,1,j,:));
    g_emp_u = squeeze(g_u_draws(1,j,:));
    sig_u_emp_rslt(j,:) = pctile(sqrt(sigma_u_emp),[0.5 1/6 5/6 0.05 0.95]);
    g_u_emp_rslt(j,:) = pctile(g_emp_u,[0.5 1/6 5/6 0.05 0.95]);
    var_emp_u = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_u.^2);
    var_emp_u = sigma_u_emp.*var_emp_u;
    R2 = var_emp_f./(var_emp_f + var_emp_u);
    r2_emp_rslt(j,:) = pctile(R2,[0.5 1/6 5/6 0.05 0.95]);

    sigma_f_tfp = squeeze(sigma_f_draws(2,2,:));
    g_tfp_f = g_f_draws(2,:)';
    var_tfp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_tfp_f.^2);
    var_tfp_f = lam_tfp_2.*sigma_f_tfp.*var_tfp_f;
    sigma_u_tfp = squeeze(sigma_u_draws(2,2,j,:));
    g_tfp_u = squeeze(g_u_draws(2,j,:));
    sig_u_tfp_rslt(j,:) = pctile(sqrt(sigma_u_tfp),[0.5 1/6 5/6 0.05 0.95]);
    g_u_tfp_rslt(j,:) = pctile(g_tfp_u,[0.5 1/6 5/6 0.05 0.95]);
    var_tfp_u = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_tfp_u.^2);
    var_tfp_u = sigma_u_tfp.*var_tfp_u;
    R2 = var_tfp_f./(var_tfp_f + var_tfp_u);
    r2_tfp_rslt(j,:) = pctile(R2,[0.5 1/6 5/6 0.05 0.95]);

    % Correlation of u components;
    sigma_u_emp_tfp = squeeze(sigma_u_draws(1,2,j,:));
    cov_u_emptfp_rslt(j,:) = pctile(sigma_u_emp_tfp,[0.5 1/6 5/6 0.05 0.95]);

    cov_u = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_u.*g_tfp_u);
    cov_u = sigma_u_emp_tfp.*cov_u;
    cor_u = cov_u./sqrt(var_emp_u .*var_tfp_u);
    cor_emp_tfp_rslt(j,:) = pctile(cor_u,[0.5 1/6 5/6 0.05 0.95]);

    % Save
    var_emp_u_all(j,:) = var_emp_u;
    var_tfp_u_all(j,:) = var_tfp_u;
    cov_emp_tfp_u_all(j,:) = cov_u;
end


% Compute R2 and correlation for aggregates
var_emp_u_agg =((share_emp.^2)'*var_emp_u_all)';
g_emp_f = g_f_draws(1,:)';
sigma_f_emp = squeeze(sigma_f_draws(1,1,:));
var_emp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_emp_f.^2);
var_emp_f = sigma_f_emp.*var_emp_f;
R2 = var_emp_f./(var_emp_f + var_emp_u_agg);
r2_emp_agg_rslt(:,1) = pctile(R2,[0.5 1/6 5/6 0.05 0.95]);

var_tfp_u_agg = ((share_tfp.^2)'*var_tfp_u_all)';
g_tfp_f = g_f_draws(2,:)';
sigma_f_tfp = squeeze(sigma_f_draws(2,2,:));
var_tfp_f = repmat(sum(diag_SW_I0),n_draws,1)+sum(diag_SW_I1)*(g_tfp_f.^2);
var_tfp_f = sigma_f_tfp.*var_tfp_f;
R2 = var_tfp_f./(var_tfp_f + var_tfp_u_agg);
r2_tfp_agg_rslt(:,1) = pctile(R2,[0.5 1/6 5/6 0.05 0.95]);

% -- TABLE Posterior -- %'%
outfile_name    = [outdir, 'Appendix_Table_01_' mlabel '.txt'];
fileID          = fopen(outfile_name,'w');
fprintf(fileID,'Sector&lam_l&lam_z&sig_l&sig_z&cov_lz&g_l&g_z&r2_l&r2_z&corr(l,z) \n');
for j = 1:9
    a = char(short_names(j));
    fprintf(fileID,[a '&']);
    fprintf(fileID,'%5.2f&',lam_emp_rslt(j,1));
    fprintf(fileID,'%5.2f&',lam_tfp_rslt(j,1));
    fprintf(fileID,'%5.2f&',sig_u_emp_rslt(j,1));
    fprintf(fileID,'%5.2f&',sig_u_tfp_rslt(j,1));
    fprintf(fileID,'%5.2f&',cov_u_emptfp_rslt(j,1));
    fprintf(fileID,'%5.2f&',g_u_emp_rslt(j,1));
    fprintf(fileID,'%5.2f&',g_u_tfp_rslt(j,1));
    fprintf(fileID,'%5.2f&',r2_emp_rslt(j,1));
    fprintf(fileID,'%5.2f&',r2_tfp_rslt(j,1));
    fprintf(fileID,'%5.2f \n',cor_emp_tfp_rslt(j,1));

    fprintf(fileID,'&');
    fprintf(fileID,'(%5.2f, %5.2f)&',lam_emp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',lam_tfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',sig_u_emp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',sig_u_tfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',cov_u_emptfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',g_u_emp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',g_u_tfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',r2_emp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',r2_tfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f) \n',cor_emp_tfp_rslt(j,2:3));

    fprintf(fileID,'&');
    fprintf(fileID,'[%5.2f, %5.2f]&',lam_emp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',lam_tfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',sig_u_emp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',sig_u_tfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',cov_u_emptfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',g_u_emp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',g_u_tfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',r2_emp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',r2_tfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f] \n',cor_emp_tfp_rslt(j,4:5));

end


fprintf(fileID,'\n\n\n');
fprintf(fileID,'Sector&lam_l&lam_z&sig_l&sig_z&cov_lz&g_l&g_z&r2_l&r2_z&corr(l,z) \n');
for j = 10:n_y
    a = char(short_names(j));
    fprintf(fileID,[a '&']);
    fprintf(fileID,'%5.2f&',lam_emp_rslt(j,1));
    fprintf(fileID,'%5.2f&',lam_tfp_rslt(j,1));
    fprintf(fileID,'%5.2f&',sig_u_emp_rslt(j,1));
    fprintf(fileID,'%5.2f&',sig_u_tfp_rslt(j,1));
    fprintf(fileID,'%5.2f&',cov_u_emptfp_rslt(j,1));
    fprintf(fileID,'%5.2f&',g_u_emp_rslt(j,1));
    fprintf(fileID,'%5.2f&',g_u_tfp_rslt(j,1));
    fprintf(fileID,'%5.2f&',r2_emp_rslt(j,1));
    fprintf(fileID,'%5.2f&',r2_tfp_rslt(j,1));
    fprintf(fileID,'%5.2f \n',cor_emp_tfp_rslt(j,1));

    fprintf(fileID,'&');
    fprintf(fileID,'(%5.2f, %5.2f)&',lam_emp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',lam_tfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',sig_u_emp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',sig_u_tfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',cov_u_emptfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',g_u_emp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',g_u_tfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',r2_emp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f)&',r2_tfp_rslt(j,2:3));
    fprintf(fileID,'(%5.2f, %5.2f) \n',cor_emp_tfp_rslt(j,2:3));

    fprintf(fileID,'&');
    fprintf(fileID,'[%5.2f, %5.2f]&',lam_emp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',lam_tfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',sig_u_emp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',sig_u_tfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',cov_u_emptfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',g_u_emp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',g_u_tfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',r2_emp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f]&',r2_tfp_rslt(j,4:5));
    fprintf(fileID,'[%5.2f, %5.2f] \n',cor_emp_tfp_rslt(j,4:5));

end

fprintf(fileID,'\n Fac&');
fprintf(fileID,'&');
fprintf(fileID,'&');
fprintf(fileID,'%5.2f&',sig_f_emp_rslt(1));
fprintf(fileID,'%5.2f&',sig_f_tfp_rslt(1));
fprintf(fileID,'%5.2f&',cov_f_emptfp_rslt(1));
fprintf(fileID,'%5.2f&',g_f_emp_rslt(1));
fprintf(fileID,'%5.2f&',g_f_tfp_rslt(1));
fprintf(fileID,'%5.2f&',r2_emp_agg_rslt(1));
fprintf(fileID,'%5.2f&',r2_tfp_agg_rslt(1));
fprintf(fileID,'%5.2f \n',cor_f_emptfp_rslt(1));

fprintf(fileID,'&');
fprintf(fileID,'&');
fprintf(fileID,'&',lam_tfp_rslt(2:3)); %#ok<CTPCT>
fprintf(fileID,'(%5.2f, %5.2f)&',sig_f_emp_rslt(2:3));
fprintf(fileID,'(%5.2f, %5.2f)&',sig_f_tfp_rslt(2:3));
fprintf(fileID,'(%5.2f, %5.2f)&',cov_f_emptfp_rslt(2:3));
fprintf(fileID,'(%5.2f, %5.2f)&',g_f_emp_rslt(2:3));
fprintf(fileID,'(%5.2f, %5.2f)&',g_f_tfp_rslt(2:3));
fprintf(fileID,'(%5.2f, %5.2f)&',r2_emp_agg_rslt(2:3));
fprintf(fileID,'(%5.2f, %5.2f)&',r2_tfp_agg_rslt(2:3));
fprintf(fileID,'(%5.2f, %5.2f) \n',cor_emp_tfp_rslt(2:3));

fprintf(fileID,'&');
fprintf(fileID,'&');
fprintf(fileID,'&');
fprintf(fileID,'[%5.2f, %5.2f]&',sig_f_emp_rslt(4:5));
fprintf(fileID,'[%5.2f, %5.2f]&',sig_f_tfp_rslt(4:5));
fprintf(fileID,'[%5.2f, %5.2f]&',cov_f_emptfp_rslt(4:5));
fprintf(fileID,'[%5.2f, %5.2f]&',g_f_emp_rslt(4:5));
fprintf(fileID,'[%5.2f, %5.2f]&',g_f_tfp_rslt(4:5));
fprintf(fileID,'[%5.2f, %5.2f]&',r2_emp_agg_rslt(4:5));
fprintf(fileID,'[%5.2f, %5.2f]&',r2_tfp_agg_rslt(4:5));
fprintf(fileID,'[%5.2f, %5.2f] \n',cor_emp_tfp_rslt(4:5));



fclose(fileID);



%% Plot Sector-specific capital trends

% Read in capital contibutions
filename = 'Capital Trends.xlsx';  
xlsname = ['../data/' filename];
cap_tfp = xlsread(xlsname,'A1:P16');
cap_emp = xlsread(xlsname,'Q1:AF16');

xproj_cap_emp = xproj_emp_sec*cap_emp';
xproj_cap_tfp = xproj_tfp_sec*cap_tfp';
xproj_cap_model = xproj_cap_emp+xproj_cap_tfp;

ylims = [-5 10; -10 10; -5 10; -5 15; 
         -5 10;  -5 10; -5 10; -5 10;
         -5 10;   0 15; -5 10;  0 15;
          0 10;  -5 10; -5 10; -5 10];

fig = figure;
for i = 1:n_y
    str = char(sector_names(i));

    x1 = xproj_cap_model(:,i)-mean(xproj_cap_model(:,i))+mean(xproj_cap_sec(:,i));
    x2 = xproj_cap_sec(:,i);
    subplot(4,4,i);
    hold on;
    plot(calvec,x1,'- r','LineWidth',1);
    plot(calvec,x2,'- k','LineWidth',2);
    hold off;
    xlim([1950 2020]);
    title(str);
    ylim(ylims(i,:))
end
orient landscape;
legend('Model','Data')
print(fig, [figdir, 'Figure_A3_' mlabel], '-dpdf','-bestfit');
close(gcf);

