% Cyclically adjust data using leads and lags of the change in the
% unemployment rate

filename = 'UNRATE.xlsx';  
xlsname = ['../data/' filename];
sheet='FRED Graph';
URATE = xlsread(xlsname,sheet,'B12:B83');   % Annual Data 1948-2019
% Padd with 1 obs for 1947;
URATE=[NaN;URATE];
fd_urate = dif(URATE,1);
nlag = 1;
nlead = 1;
x = NaN(dnobs,nlag+nlead+1);
j = 1;
for i = nlag:-1:-nlead
    tmp = lag(fd_urate,i);
    x(:,j) = tmp(1:dnobs);
    j = j+1; 
end
% Save over Full-Sample Period
[~,calvec_u,~] = calendar_make([1947 1],[2019 1],n_period);
ismpl = smpl(calvec_u,First_obs,Last_obs,n_period);
x = x(ismpl==1,:);

alist = {...
    'va_sectoral_data' ... 
    'va_aggregate_data_chain' ...
    'va_aggregate_data_fixed_weight' ...
    'va_aggregate_data_first' ...
    'va_aggregate_data_last' ...
    'tfp_sectoral_data' ... 
    'tfp_aggregate_data_fixed_weight' ...
    'emp_sectoral_data' ... 
    'emp_aggregate_data_fixed_weight' ...
    'dlf' ...
    'emp_sectoral_data_dlf' ... 
    'emp_aggregate_data_fixed_weight_dlf' ...
    'cap_sectoral_data'
    }';

for iseries = 1:size(alist,1)
    ustr = char(alist(iseries));
    str_tmp = [matdir ustr];
    load(str_tmp);
    res = NaN(dnobs,1);
    eval(['ymat = ' ustr ';']);
    eval([ustr '_ca = NaN(size(ymat));']);
    for ii = 1:size(ymat,2)
        y = ymat(:,ii);
        tmp = packr([y x]);
        yp = tmp(:,1);
        xp = tmp(:,2:end);
        ypm = yp - mean(yp);
        xpm = xp - mean(xp);
        b = xpm\ypm;
        res = y - x*b;
        eval([ustr '_ca(:,ii) = res;']);
    end
end
