clc
clear all


format shortG


%% read in capital flow and make use tables
cap_flow=readtable('input_output_tables.xlsx','Sheet',1);
make_use=readtable('input_output_tables.xlsx','Sheet',2);
leontief=readtable('input_output_tables.xlsx','Sheet',3);

%% graph capital flow
agr_flow=nonzeros(table2array(cap_flow(1,2:17)))';
min_flow=nonzeros(table2array(cap_flow(2,2:17)))';
util_flow=nonzeros(table2array(cap_flow(3,2:17)))';
const_flow=nonzeros(table2array(cap_flow(4,2:17)))';
durgds_flow=nonzeros(table2array(cap_flow(5,2:17)))';
ndgds_flow=nonzeros(table2array(cap_flow(6,2:17)))';
whtrd_flow=nonzeros(table2array(cap_flow(7,2:17)))';
rettrd_flow=nonzeros(table2array(cap_flow(8,2:17)))';
tw_flow=nonzeros(table2array(cap_flow(9,2:17)))';
inf_flow=nonzeros(table2array(cap_flow(10,2:17)))';
firex_flow=nonzeros(table2array(cap_flow(11,2:17)))';
pbs_flow=nonzeros(table2array(cap_flow(12,2:17)))';
edh_flow=nonzeros(table2array(cap_flow(13,2:17)))';
aefs_flow=nonzeros(table2array(cap_flow(14,2:17)))';
other_flow=nonzeros(table2array(cap_flow(15,2:17)))';
house_flow=nonzeros(table2array(cap_flow(16,2:17)))';

weights_flow=[agr_flow min_flow util_flow const_flow durgds_flow ndgds_flow whtrd_flow ...
    rettrd_flow tw_flow inf_flow firex_flow pbs_flow edh_flow aefs_flow other_flow house_flow];

From2_flow=[2];
To2_flow=[2];
From4_flow=ones(1,16)*4;
To4_flow=[1:16];
From5_flow=ones(1,16)*5;
To5_flow=[1:16];
From6_flow=ones(1,5)*6;
To6_flow=[3 8 11 12 14];
From7_flow=ones(1,15)*7;
To7_flow=[1:15];
From8_flow=ones(1,16)*8;
To8_flow=[1:16];
From9_flow=ones(1,14)*9;
To9_flow=[1:12 14 15];
From10_flow=ones(1,14)*10;
To10_flow=[2:15];
From11_flow=[11];
To11_flow=[16];
From12_flow=ones(1,15)*12;
To12_flow=[1:15];
From_flow = [From2_flow From4_flow From5_flow From6_flow From7_flow From8_flow ...
    From9_flow From10_flow From11_flow From12_flow];
To_flow = [To2_flow To4_flow To5_flow To6_flow To7_flow To8_flow To9_flow ...
    To10_flow To11_flow To12_flow];
G_flow=graph(From_flow, To_flow, weights_flow);
LWidths = 5*G_flow.Edges.Weight/max(G_flow.Edges.Weight);
fig=figure('Units','Inches','Position',[1 1 6.5 5]);
p_flow=plot(G_flow,'LineWidth',LWidths);
labelnode(p_flow,1,'Agriculture')
labelnode(p_flow,2,'Mining')
labelnode(p_flow,3,'Utilities')
labelnode(p_flow,4,'Construction')
labelnode(p_flow,5,'Durable \newline Goods')
labelnode(p_flow,6,'Nondurable \newline Goods')
labelnode(p_flow,7,'Wholesale \newline Trade')
labelnode(p_flow,8,'Retail \newline Trade')
labelnode(p_flow,9,'Trans. & Ware.')
labelnode(p_flow,10,'Information')
labelnode(p_flow,11,'FIRE (x-Housing)')
labelnode(p_flow,12,'PBS')
labelnode(p_flow,13,'Educ. & Health')
labelnode(p_flow,14,'Arts, Ent. \newline & Food Svc')
labelnode(p_flow,15,'Other Services \newline (x-Gov.)')
labelnode(p_flow,16,'Housing')
X_flow_labels=[0 0 0.1  0    0   0 0 0 0 0 0 0 0 0 0 0];
Y_flow_labels=[0 0 0   -0.1 -0.2 0 0 0 0 0 0 0 0 0 0 0];
text(p_flow.XData+X_flow_labels, p_flow.YData+Y_flow_labels ,p_flow.NodeLabel, ...
    'FontWeight', 'bold','VerticalAlignment','top',...
    'HorizontalAlignment', 'center',...
    'FontSize', 8)
p_flow.NodeLabel = {}; 
for i=1:16
    highlight(p_flow, i, 'MarkerSize', 20*(cap_flow.Average(i)+.01)/max(cap_flow.Average));
end
axis off
% title('Investment Network')
orient landscape;
print(fig, 'Figure_08.pdf', '-dpdf','-fillpage');

